﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Globalization;
using CsvHelper;
using CsvHelper.Configuration.Attributes;
using System.Linq;

namespace TextFormat
{
    internal class CSVClass<T>:IFileProcessor
    {
        public List<T> ReadFile<T>(string fileName)
        {
            try
            {
                if (File.Exists(fileName + ".csv"))
                {
                    using (var reader = new StreamReader(fileName + ".csv"))
                    using (var csv = new CsvReader(reader, System.Globalization.CultureInfo.InvariantCulture))
                    {
                        Console.WriteLine("Успешно cчитано");
                        return csv.GetRecords<T>().ToList();
                    }
                }
                else
                {
                    throw new FileNotFoundException();
                }

            }
            catch (FileNotFoundException)
            {
                Console.WriteLine("Файл не найден");
                return new List<T>();
            }
            catch (Exception ex)
            {
                Console.WriteLine($"{ex.Message}");
                return new List<T>();
            }
        }

        public void WriteFile<T>(List<T> data, string fileName)
        {
            try
            {
                using (var writer = new StreamWriter(fileName + ".csv"))
                using (var csv = new CsvWriter(writer, System.Globalization.CultureInfo.InvariantCulture))
                {

                    csv.WriteRecords(data);
                    Console.WriteLine("Успешно записано");
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

    }
}
