﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace TextFormat
{
    internal class JsonClass<T> : IFileProcessor
    {
        public List<T> ReadFile<T>(string fileName)
        {
            try
            {
                if (File.Exists(fileName + ".json"))
                {
                    var json = File.ReadAllText(fileName + ".json");

                    var serializeSettings = new JsonSerializerSettings();
                    serializeSettings.DateParseHandling = DateParseHandling.None;
                    serializeSettings.Converters.Add(new MultiFormatDateConverter
                    {
                        DateTimeFormats = new List<string> { "dd/MM/yyyy", "yyyy-MM-dd" }
                    });
                    Console.WriteLine("Успешно считано");
                    return JsonConvert.DeserializeObject<List<T>>(json, serializeSettings);
                }
                else
                {
                    throw new FileNotFoundException();
                }
                
            }
            catch(FileNotFoundException)
            {
                Console.WriteLine("Файл не найден");
                return new List<T>();
            }
            catch (Exception ex)
            {
                Console.WriteLine($"{ex.Message}"); 
                return new List<T>();
            }
        }

        public void WriteFile<T>(List<T> data, string fileName)
        {
            try 
            {
                var settings = new JsonSerializerSettings();
                settings.Converters.Add(new IsoDateTimeConverter() { DateTimeFormat = "dd/MM/yyyy" });
                var json = JsonConvert.SerializeObject(data, settings);
                File.WriteAllText(fileName + ".json", json);
                Console.WriteLine("Успешно записано");
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

    }
}


