﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Xml.Serialization;

namespace TextFormat
{
    internal class XMLClass<T>:IFileProcessor
    {
        public List<T> ReadFile<T>(string fileName)
        {
            try
            {
                if (File.Exists(fileName + ".xml"))
                {
                    List<T> list = new List<T>();
                    XmlSerializer serializer = new XmlSerializer(typeof(List<T>));
                    using (FileStream writer = new FileStream(fileName + ".xml", FileMode.OpenOrCreate))
                    {
                        list = (List<T>)serializer.Deserialize(writer);
                    }
                    Console.WriteLine("Успешно считано");
                    return list;
                }
                else
                {
                    throw new FileNotFoundException();
                }

            }
            catch (FileNotFoundException)
            {
                Console.WriteLine("Файл не найден");
                return new List<T>();
            }
            catch (Exception ex)
            {
                Console.WriteLine($"{ex.Message}");
                return new List<T>();
            }
        }

        public void WriteFile<T>(List<T> data, string fileName)
        {
            try
            {
                List<T> list = new List<T>();
                XmlSerializer serializer = new XmlSerializer(typeof(List<T>));
                using (StreamWriter writer = new StreamWriter(fileName + ".xml",false))
                {
                    serializer.Serialize(writer, data);
                }
                Console.WriteLine("Успешно записано");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

    }
}
