﻿using System;
using System.Collections.Generic;
using System.IO;
using YamlDotNet.Serialization.NamingConventions;
using YamlDotNet.Serialization;
using System.Linq;

namespace TextFormat
{
    internal class YAMLClass<T>:IFileProcessor
    {
        public List<T> ReadFile<T>(string fileName)
        {
            try
            {
                if (File.Exists(fileName + ".yaml"))
                {
                    var deserializer = new DeserializerBuilder()
                    .WithNamingConvention(CamelCaseNamingConvention.Instance)
                    .Build();

                    var yaml = File.ReadAllText(fileName + ".yaml");
                    Console.WriteLine("Успешно считано");
                    return deserializer.Deserialize<List<T>>(yaml);
                }
                else
                {
                    throw new FileNotFoundException();
                }

            }
            catch (FileNotFoundException)
            {
                Console.WriteLine("Файл не найден");
                return new List<T>();
            }
            catch (Exception ex)
            {
                Console.WriteLine($"{ex.Message}");
                return new List<T>();
            }
        }

        public void WriteFile<T>(List<T> data, string fileName)
        {
            try
            {
                var serializer = new SerializerBuilder()
                .WithNamingConvention(CamelCaseNamingConvention.Instance)
                .Build();

                var yaml = serializer.Serialize(data);
                File.WriteAllText(fileName + ".yaml", yaml);
                Console.WriteLine("Успешно записано");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

    }
}
